## magics++ 2.28.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF

# TODO:
#  * fix python module generation Magics.py to __init__.py
#  * cpack ecbuild/cmake macros into tar.gz
#  * unit tests check that certain files are produced and not empty
#  * pkg-config needed for metview

# Missing dependencies:
#   * ghostscript ( is it really needed? -- to confirm )

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(MAGICS_INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )

###############################################################################
# some variables of this project

ecbuild_use_package(PROJECT grib_api VERSION 1.12.3 REQUIRED)
# grib_api is required for now
set( HAVE_GRIB 1 )

ecbuild_add_option( FEATURE BUFR
                    DEFAULT ON
                    DESCRIPTION "BUFR support"
                    REQUIRED_PACKAGES "PROJECT libemos VERSION 4.0.5" )

ecbuild_add_option( FEATURE ODB
                    DEFAULT ON
                    DESCRIPTION "ODB support"
                    REQUIRED_PACKAGES 
						"PROJECT odb_api VERSION 0.10.2"
						"PROJECT eckit   VERSION 0.9.0" )

ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo )

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C CXX" )

ecbuild_add_option( FEATURE SPOT
                    DEFAULT OFF
                    DESCRIPTION "enable spot support"
                    REQUIRED_PACKAGES "PROJECT spot" )

ecbuild_add_option( FEATURE PYTHON
                    DEFAULT ON
                    DESCRIPTION "enable python interface"
                    REQUIRED_PACKAGES Python SWIG NumPy )

if( HAVE_PYTHON )
   include(UseSWIG)
endif()

ecbuild_add_option( FEATURE FORTRAN
                    DEFAULT ON
                    DESCRIPTION "enable Fortran interface" )

if( HAVE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE QT5
                    DEFAULT OFF
                    DESCRIPTION "use Qt5 instead of version 4" )

ecbuild_add_option( FEATURE PNG
                    DESCRIPTION "support for PNG decoding/encoding"
                    DEFAULT ON
                    REQUIRED_PACKAGES PNG
)

if( HAVE_PNG )
    add_definitions( ${PNG_DEFINITIONS} )
endif()

option( BUILD_SHARED_LIBS  "Set to BOTH to build static library in addition to shared"  ON )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

# Regression definitions
set( MAGICS_REFERENCE_VERSIONS            "2.26.2" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_BINARY_DIR}/python )

###############################################################################
# projects

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

#cmake_add_cxx_flags("-gdwarf-2")
cmake_add_c_flags("-std=c99")

### Metview and Qt

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    message(FATAL_ERROR "Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    message(STATUS "TESTING for Metview ...")
    unset(MAGICS_ONLY)

    if( HAVE_QT5 )
      find_package(Qt5Widgets REQUIRED)
      if( Qt5Widgets_FOUND )
          message(STATUS "Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
          include_directories(${Qt5Widgets_INCLUDE_DIRS})
          set( MAGICS_QT 1)
          set( MAGICS_QT5 1)
          set( qt yes)
          add_definitions( -DMAGICS_QT5 )
      else()
          message(FATAL_ERROR "Qt5 was NOT found ...")
      endif()
    else()
    find_package(Qt4 4.4.3 REQUIRED QtCore QtGui QtXml )
    if( QT_FOUND )
		  include( ${QT_USE_FILE} )
		  set( MAGICS_QT 1)
		  set( qt yes)
    endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads ) 

# set(Boost_USE_STATIC_LIBS        ON)
# set(Boost_NO_SYSTEM_PATHS        ON)
# set(Boost_USE_MULTITHREADED      ON)
ecbuild_add_extra_search_paths( boost )

find_package( Boost 1.49.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT  REQUIRED )

###############################################################################
# contents

set( MAGICS_TPLS grib_api spot EXPAT NetCDF PNG Proj4 libemos )

set( MAGICS_INCLUDE_DIRS 
     ${CMAKE_CURRENT_SOURCE_DIR}/src 
     ${CMAKE_BINARY_SOURCE_DIR}/src 
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common 
     ${CMAKE_CURRENT_BINARY_DIR}/src/params 
     ${CMAKE_CURRENT_BINARY_DIR}/src 
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common  
     ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
     ${CMAKE_CURRENT_SOURCE_DIR}/src/web
     ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
     ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/utils
     ${CMAKE_CURRENT_SOURCE_DIR}/src/libMagWrapper
     ${Boost_INCLUDE_DIRS} )

if( HAVE_CAIRO )
  list( APPEND MAGICS_TPLS PangoCairo )
  list( APPEND MAGICS_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS} )
endif()

if( HAVE_ODB )
  list( APPEND MAGICS_TPLS odb_api )
  list( APPEND MAGICS_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/oda
        ${ODB_API_INCLUDE_DIRS}
		${ECKIT_INCLUDE_DIRS} )
endif()

set( MAGICS_LIBRARIES    MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( NOT ${TPL} STREQUAL "LIBEMOS" ) # don't add libemos definitions
    list( APPEND MAGICS_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    endif()
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
endforeach()

if( HAVE_BUFR )
	list( APPEND MAGICS_EXTRA_DEFINITIONS   fortfloat=double fortint=int )
    ecbuild_find_fortranlibs()
	list( APPEND MAGICS_EXTRA_LIBRARIES ${FORTRAN_LIBRARIES} )
endif()
if( WITH_QT_DEBUG )
	list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
endif()

if( MAGICS_QT )
  if( MAGICS_QT5 )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )
  else()
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${QT_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES     ${QT_LIBRARIES} )
endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
  list( APPEND MAGICS_EXTRA_DEFINITIONS HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )

# scripts
add_subdirectory( tools )

# source files
add_subdirectory( src )

# shared files
add_subdirectory( share )

# python interface 
add_subdirectory( python )

# apps directory
add_subdirectory( apps )

# Test directory
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources 
		DONT_PACK_DIRS tools/versioncmp 
		tools/regression 
		regression
		docs
		toolsjs
		test/old
		tools/xml 
		tools/use_scripts
		tools/versioncmp_folders)

ecbuild_add_resources( TARGET internal 
		DONT_PACK configure.lxab
		configure.local
		configure.ecgb
		configure.ecmwf
)

############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/wiki/display/MAGP/Magics" )
ecbuild_pkgconfig()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
###############################################################################

configure_file( magics_config.h.in  magics_config.h  )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})

###############################################################################


function( add_metview_definition_file )
   
    set( single_value_args ACTION BASENAME FILE ) 
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )
     
    add_custom_command( 
            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
            DEPENDS ${_p_FILE}
      )
     
     
    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)

endfunction(add_metview_definition_file)

add_subdirectory( params )



foreach( file ${magics_xmls} )

      get_filename_component( path     ${file} PATH   )
      get_filename_component( basefile ${file} NAME_WE )

      set( ouputfiles ${path}/${basefile}Attributes.h ${path}/${basefile}Attributes.cc )
      
      # generate the code
      add_custom_command( 
            OUTPUT  ${ouputfiles}
            COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2cc_new.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
            DEPENDS ${file}
      )

      set_source_files_properties( ${basefile}Attributes.h  GENERATED )
      set_source_files_properties( ${basefile}Attributes.cc GENERATED )

      list( APPEND magics_params_srcs ${ouputfiles} )

endforeach()
     
if ( metview )

	foreach( file ${metview_xmls} )
	      get_filename_component( path     ${file} PATH   )
          get_filename_component( basefile ${file} NAME_WE )
		  
		  set( metviewfiles ${path}/${basefile}Wrapper.h ${path}/${basefile}Wrapper.cc )
		  
		  
		# generate the code
		  add_custom_command( 
				OUTPUT  ${metviewfiles}
				COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2mv.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
				DEPENDS ${file}
			)

		  set_source_files_properties( ${basefile}Wrapper.h  GENERATED )
          set_source_files_properties( ${basefile}Wrapper.cc GENERATED )
          list( APPEND metview_wrappers_srcs ${metviewfiles} )
      endforeach()

     if(qt)
        SET(qt_drivers_HEADERS drivers/MgQ/MgQPlotScene.h)
        if( MAGICS_QT5 )
          QT5_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        else()
          QT4_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        endif()        
        list( APPEND drivers_srcs  drivers/MgQ/MgQPlotScene.cc  ${qt_drivers_HEADERS_MOC})
     endif()
endif()


add_custom_target( magics_params DEPENDS ${magics_params_srcs} )
add_custom_target( mv_params DEPENDS ${metview_wrappers_srcs} )
###############################################################################

add_subdirectory( common )
add_subdirectory( basic )
add_subdirectory( web )
add_subdirectory( visualisers )
add_subdirectory( drivers )
add_subdirectory( decoders )
add_subdirectory( terralib )
add_subdirectory( eckit_readers )

if( metview )
	add_subdirectory( libMagWrapper )
endif()

if( HAVE_ODB )
	add_subdirectory( oda )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/common )

ecbuild_add_library( TARGET    MagPlus
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs} 
                        ${common_srcs} 
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${terralib_srcs} 
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS} MAGICS_EXCEPTION=on
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                     TYPE SHARED )

ecbuild_add_library( TARGET      MagPlusSingle
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

ecbuild_add_library( TARGET      MagPlusDouble
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

if ( BUILD_SHARED_LIBS STREQUAL "BOTH" )
ecbuild_add_library( TARGET    MagPlusStatic
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs} 
                        ${common_srcs} 
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${terralib_srcs} 
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}  
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES} 
                     TYPE STATIC
                     OUTPUT_NAME MagPlus )

ecbuild_add_library( TARGET      MagPlusSingleStatic 
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusSingle )

ecbuild_add_library( TARGET      MagPlusDoubleStatic
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusDouble )

endif()

if( metview )
 include_directories(  ${CMAKE_CURRENT_SOURCE_DIR} 
                        ${CMAKE_CURRENT_BINARY_DIR} 
                        ${CMAKE_CURRENT_BINARY_DIR}/params 
                        ${CMAKE_CURRENT_SOURCE_DIR}/common  
                        ${CMAKE_CURRENT_SOURCE_DIR}/basic
                        ${CMAKE_CURRENT_SOURCE_DIR}/web
                        ${CMAKE_CURRENT_SOURCE_DIR}/visualisers
                        ${CMAKE_CURRENT_SOURCE_DIR}/drivers
                        ${CMAKE_CURRENT_SOURCE_DIR}/decoders
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/kernel
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/utils 
                        ${CMAKE_CURRENT_SOURCE_DIR}/libMagWrapper )
  

                        
  ecbuild_add_library( TARGET    MagWrapper
                     DEPENDS   mv_params magics_params
                     SOURCES
                        magics.h
                        ${metview_srcs} 
                        ${metview_wrappers_srcs} 
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}                   
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                    TYPE STATIC		
                    )
   list( APPEND attributes_include
				OutputHandlerAttributes.h 
				FortranRootSceneNodeAttributes.h  
                BinningObjectAttributes.h
                GribDecoderAttributes.h
                DateGribLoopStepAttributes.h
                GribLoopAttributes.h
                GeoRectangularProjectionAttributes.h
                LegendVisitorAttributes.h
				XmlRootNodeAttributes.h 
				WrepRootNodeAttributes.h
                ContinuousLegendMethodAttributes.h
                HistogramLegendMethodAttributes.h
                XmlBasicNodeAttributes.h
                ImagePlottingAttributes.h
                LookupTableModeAttributes.h
                FixedTableModeAttributes.h
				)
   if(qt)
     list(APPEND attributes_include
                 QtDriverAttributes.h)
   endif()

   install( FILES terralib/kernel/TeProjection.h
				   terralib/kernel/TeCoord2D.h 
				   terralib/kernel/TeDefines.h 
				   terralib/kernel/TePrecision.h 
				   terralib/kernel/TeSingleton.h 
				   terralib/kernel/TeDatum.h 
				   terralib/kernel/TeUtils.h
				   terralib/kernel/TeProgress.h
				   terralib/kernel/TeProgressBase.h
				   
				   
				   DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES VectorOfPointers.h  DESTINATION ${INSTALL_INCLUDE_DIR})
   foreach( file ${attributes_include} )
     install( FILES ${CMAKE_CURRENT_BINARY_DIR}/params/${file}  DESTINATION ${INSTALL_INCLUDE_DIR})
   endforeach()
   install( FILES ${metview_include} DESTINATION ${INSTALL_INCLUDE_DIR})
endif()
install( FILES magics.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== src/common/CMakeLists.txt ===
list( APPEND _common_srcs

	OutputFactory.h MagLog.h
	BaseParameter.h Colour.h MagException.h
	Factory.cc Factory.h
	ParameterManager.h Frame.h Layout.h
	PaperPoint.h GeoPoint.h  Tokenizer.h Node.h MagTranslator.h
	ImageProperties.h LogoPlotting.h
	ImportObject.h ColourTable.h PageID.h
	Transformation.h Dimension.h
	XmlNode.h XmlTree.h XmlReader.h BackgroundColour.h
	ColourTableDefinition.h ColourTableDefinitionCompute.h ColourTableDefinitionComputeInterface.h
	ColourTableDefinitionList.h ColourTableDefinitionListInterface.h 
	TableDefinition.h TableDefinitionList.h TableDefinitionListInterface.h
	TableDefinitionCompute.h TableDefinitionComputeInterface.h
	HeightTableDefinition.h LevelTableDefinition.h IntervalMap.h PaperDimension.h
	Matrix.h MatrixHandler.h Data.h Decoder.h
	BasePointsHandler.h RasterData.h  Visualiser.h CustomisedPoint.h PointsHandler.h
	MetaData.h
	Polyline.h
	Text.h
	Symbol.h
	BinaryObject.h
	Arrow.h
	Flag.h
	Image.h 
	ArrowProperties.h
	MagicsParameter.cc MagicsParameter.h Clipper.h LogoPlottingBase.h
	TableDefinitionCompute.cc 
	TableDefinitionList.cc
	Coordinate.h OutputHandler.h
	MagFont.h 
	AnimationRules.h SymbolItem.h
	UserPoint.h Label.h
	Timer.h
	CustomisedPoint.h Static.h DriverStatic.h ProgressObject.h PolyCoast.h
	ProgressTask.h FullPaperPoint.h
	BasePointsHandler.h PointsHandler.h Decoder.h Data.h
	Visualiser.h MatrixHandler.h
	Seconds.h
	Matrix.h Matrix.cc
	Path.h
	MagicsSingleton.h
	PlotManager.h
	Image.h 
	XmlReader.h XmlTree.h XmlNode.h
	MagicsFormat.h
	CartesianTransformation.h
	Dimension.cc
	XCoordinate.h YCoordinate.h marsmachine.h linux.h aix.h
	Thread.h MutexCond.h Mutex.h AutoLock.h ThreadControler.h Task.h MagExceptions.h ThreadSingleton.h 
	DataStats.h SciMethods.h Tephigram.cc  Tephigram.h

# sources
	Data.cc Matrix.cc MagicsCalls.cc Static.cc DriverStatic.cc MagLog.cc Colour.cc Transformation.cc MagException.cc
	BaseParameter.cc ParameterManager.cc  
	Tokenizer.cc Timer.cc Seconds.cc Label.cc
	ArrowProperties.cc
	XmlReader.cc XmlTree.cc XmlNode.cc Dimension.cc
	MetaData.cc
	MagicsFormat.cc
	OutputHandler.cc  OutputFactory.cc
	MagFont.cc
	ColourTable.cc ColourTableDefinitionList.cc
	ColourTableDefinitionCompute.cc CartesianTransformation.cc
	BinaryObject.cc
	Coordinate.cc
	LogoPlotting.cc
	PageID.cc AnimationRules.cc Layout.cc SymbolItem.cc Symbol.cc Polyline.cc
	Text.cc Flag.cc  
	Mutex.cc MutexCond.cc Thread.cc MagExceptions.cc AutoLocker.cc
	ThreadControler.cc Task.cc
	DataStats.cc SciMethods.cc BasePointsHandler.cc PointsHandler.cc ProgressObject.cc

# projection
    GeoRectangularProjection.cc  PolarStereographicProjection.cc TaylorProjection.cc
    GeoRectangularProjection.h   PolarStereographicProjection.h SatelliteProjection.h TaylorProjection.h
    Proj4Projection.cc  Proj4Projection.h

# unused


 )


list( APPEND _common_templates 
    Factory.cc 
    MagicsParameter.cc
    TableDefinitionList.cc
    TableDefinitionCompute.cc
 )

foreach( file ${_common_srcs} )
  list( APPEND common_srcs common/${file} )
endforeach()
foreach( file ${_common_templates} )
  list( APPEND common_templates common/${file} )
endforeach()

set( common_srcs ${common_srcs} PARENT_SCOPE )
set( common_templates ${common_templates} PARENT_SCOPE )

if ( metview )
	list (APPEND metview_include 
				common/MagLog.h 
				common/MagTranslator.h 
				common/Factory.h 
				common/Factory.cc 
				common/Colour.h 
				common/Tokenizer.h 
				common/MagException.h 
				common/ParameterManager.h
				common/PaperPoint.h 
				common/Matrix.h
				common/BaseParameter.h
				common/OutputHandler.h
				common/OutputFactory.h
				common/Layout.h
				common/XmlNode.h 
				common/Transformation.h
				common/UserPoint.h
				common/CustomisedPoint.h
				common/XmlTree.h
				common/XmlReader.h
				common/RasterData.h
				common/Decoder.h
				common/Data.h
				common/MatrixHandler.h
				common/BasePointsHandler.h
				common/Timer.h
                common/DataStats.h
                common/IntervalMap.h
                common/GeoRectangularProjection.h
                common/Text.h
                common/Label.h
                common/MagFont.h
                common/Image.h
                common/ImageProperties.h
                common/ColourTable.h
                common/ColourTableDefinition.h
                common/PointsHandler.h
				)
	set( metview_include ${metview_include} PARENT_SCOPE )
endif()
install ( FILES magics_api.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== debian/changelog ===
magics++ (2.28.0-4) unstable; urgency=medium

  * Add missing license information to debian/copyright;
    thanks to Thorsten Alteholz.
  * Add Python3 support.
  * Update numpy.i from numpy.git for python3

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Jun 2016 08:57:36 +0100

magics++ (2.28.0-3) unstable; urgency=medium

  * Remove obsolete openjpeg dependencies. Closes: #826820
  * g++6, unique_ptr compilation fixes

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Jun 2016 15:05:00 +0100

magics++ (2.28.0-2) unstable; urgency=medium

  * Standards-Version: 3.9.8
  * Fix incorrect libgfortran path shipped in cmake files.	

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 25 May 2016 17:46:52 +0100

magics++ (2.28.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches:
    - compile-fixes.patch: fixed upstream

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Mar 2016 07:44:16 +0000

magics++ (2.26.2-3) unstable; urgency=medium

  * Build against openjpeg, not jasper, as jasper is being dropped
    from Debian (long-dead, insecure).
  * Link against grib-api >= 1.14.5-2 to pick up its jasper change.
  * Standards-Version: 3.9.7

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 29 Feb 2016 09:42:13 +0000

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 9) , dh-buildinfo, gfortran, cmake, chrpath,
 dh-python,  swig,
 python-all-dev, python-numpy, 
 python3-all-dev, python3-numpy,
 libhdf5-serial-dev | libhdf5-dev, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9-1), libgeotiff-dev,
 libgrib-api-dev (>= 1.14.5-2), libgrib-api-tools, libaec-dev,
 libterralib-dev, 
 libcairo2-dev, libpango1.0-dev,
 ttf-dejavu-core, libxml-parser-perl, 
 ghostscript, zlib1g-dev, libboost-dev, libproj-dev, 
 qtbase5-dev-tools, qtbase5-dev, qt5-qmake
Standards-Version: 3.9.8
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Git: git://anonscm.debian.org/debian-science/packages/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, libterralib-dev, magics++
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh,
 ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python, python-simplejson
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: python3-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-simplejson
Description: Python3 support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides Python3 support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) -std=c++11
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel --with python2,python3 --with-buildsystem=cmake

# To fix cmake output change these
OLD_GF_PATH=$(shell gfortran -print-search-dirs | grep install | cut -f2 -d' '  )libgfortran.so
NEW_GF_PATH:=$(LIBDIR)/libgfortran.so.3

export extra_flags +=  \
	-DCMAKE_PREFIX_PATH=${LIBDIR}/cmake/grib_api \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBGRIB_API=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	rm -rf debian/build-py*
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	       	$(extra_flags) 
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
	       	$(extra_flags) 
	(cd python/Magics && ln -s $(CURDIR)/debian/build-py3/python/Magics/Magics.i )

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py2/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py2  check )
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	$(MAKE) -C debian/build-py3/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python3.5 \
			DESTDIR=$(CURDIR)/debian/python3-magics++ \ MAGPLUS_HOME=$(CURDIR) 
	$(MAKE) -C debian/build-py2/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python2.7 \
			DESTDIR=$(CURDIR)/debian/python-magics++ \ MAGPLUS_HOME=$(CURDIR) 
	dh_auto_install --builddirectory=debian/build-py3
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
	| sed -e 's%$(OLD_GF_PATH)%$(NEW_GF_PATH)%'   \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_python3 /usr/lib/python3*/site-packages/Magics
	dh_numpy -p python-magics++
	dh_numpy3 -p python3-magics++
	find debian/tmp debian/python*-magics++   -name '*.so*' -exec chrpath -d {} \;
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
